/* 
 *  Ths code in this file is part of tcptrack. For more information see
 *    http://www.rhythm.cx/~steve/devel/tcptrack
 *
 *     Copyright (C) Steve Benson - 2003
 *
 *  tcptrack is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your
 *  option) any later version.
 *   
 *  tcptrack is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  
 */
#ifndef TCCONTAINER_H
#define TCCONTAINER_H 1

#define _BSD_SOURCE 1
#define _REENTRANT
#include <sys/types.h>
#include <pthread.h>
#include "List.h"
#include "ListIterator.h"
#include "headers.h"
#include "TCPConnection.h"
#include "Collector.h"
#include "TCPConnection.h"
#include "SortedIterator.h"

typedef List<TCPConnection *> TCPConnectionList;
typedef ListIterator<TCPConnection *> TCPConnectionListIterator;
class View;

class TCContainer
{
public:
	TCContainer();
	~TCContainer();
	bool processPacket( const u_char *packet );
	TCPConnectionListIterator getIterator();
	unsigned int numConnections();
	void testSort();

	void lock();
	void unlock();

	void maint_thread_run();
	
	SortedIterator getSortedIterator();
private:

	Collector collector;
	TCPConnectionList conlist; // this should be changed to a 
	                           // hashtable at some point.
	pthread_mutex_t conlist_lock;
	pthread_mutex_t pqueue_lock;
	pthread_t maint_thread_tid;
	pthread_t qrunner_thread_tid;
	bool run_maint_thread;
	bool run_qrunner_thread;

	View *theView;
};

void *maint_thread_func( void * arg );

#endif
